package com.yeejoin.amos.boot.biz.common.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import io.swagger.annotations.ApiModel;
import lombok.Data;

/**
 * @author Administrator
 */
@Data
@ApiModel(value = "CommonVideoDto", description = "通用视频信息")
public class CommonVideoDto {
  private String key;

  private String url;

  private String type;

  /**
   * 列表时摄像头的名称，查询摄像头列表时要显示，故必须有此字段
   */
  @JsonIgnore
  private String label;

  /**
   * 预览时摄像头的名称,摄像头预览时画面上有名称，故多数字段为空
   */
  private String title;

  private String thumb;

  @JsonIgnore
  private String parent;
  /**
   * 请判断播放端是否要求播放视频为H265编码格式,1表示需要，0表示不要求
   */
  private Integer supportH265;
  /**
   * 视频清晰度，1-高清（主码流）、2-流畅（子码流）
   */
  private Integer quality;

}
