package com.yeejoin.amos.boot.biz.common.feign;

import org.springframework.boot.autoconfigure.http.HttpMessageConverters;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;


import feign.codec.Encoder;
import feign.form.spring.SpringFormEncoder;
import org.springframework.beans.factory.ObjectFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.openfeign.support.SpringEncoder;
/**
 * @author DELL
 */
@Configuration
public class FeignConfiguration {

    /**
     * 创建Feign请求拦截器，在发送请求前设置认证的token,各个微服务将token设置到环境变量中来达到通用
     * @return
     */
    @Bean
    public FeignAuthRequestInterceptor basicAuthRequestInterceptor() {
        return new FeignAuthRequestInterceptor();
    }

    @Autowired
    private ObjectFactory<HttpMessageConverters> messageConverters;

    @Bean
    public Encoder feignComFormEncoder() {
        return new SpringFormEncoder(new SpringEncoder(messageConverters));
    }


}
