package com.yeejoin.amos.api.householdapi.controller;

import com.yeejoin.amos.api.householdapi.face.model.HouseholdPvApiDto;
import com.yeejoin.amos.api.householdapi.face.service.impl.HouseholdPvApiServiceImpl;
import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 户用光伏-厂商API haders
 *
 * @author system_generator
 * @date 2023-06-07
 */
@RestController
@Api(tags = "户用光伏-厂商API hadersApi")
@RequestMapping(value = "/household-pv-api")
public class HouseholdPvApiController {

    @Autowired
	HouseholdPvApiServiceImpl householdPvApiServiceImpl;

    /**
     * 新增户用光伏-厂商API haders
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增户用光伏-厂商API haders", notes = "新增户用光伏-厂商API haders")
	public ResponseModel<HouseholdPvApiDto> save(@RequestBody HouseholdPvApiDto model) {
	    model = householdPvApiServiceImpl.createWithModel(model);
	    return ResponseHelper.buildResponse(model);
	}

	/**
     * 根据sequenceNbr更新
     *
     * @param sequenceNbr 主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "根据sequenceNbr更新户用光伏-厂商API haders", notes = "根据sequenceNbr更新户用光伏-厂商API haders")
	public ResponseModel<HouseholdPvApiDto> updateBySequenceNbrHouseholdPvApi(@RequestBody HouseholdPvApiDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr) {
	    model.setSequenceNbr(sequenceNbr);
	    return ResponseHelper.buildResponse(householdPvApiServiceImpl.updateWithModel(model));
	}

	/**
     * 根据sequenceNbr删除
     *
     * @param sequenceNbr 主键
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @DeleteMapping(value = "/{sequenceNbr}")
    @ApiOperation(httpMethod = "DELETE", value = "根据sequenceNbr删除户用光伏-厂商API haders", notes = "根据sequenceNbr删除户用光伏-厂商API haders")
    public ResponseModel<Boolean> deleteBySequenceNbr(HttpServletRequest request, @PathVariable(value = "sequenceNbr") Long sequenceNbr){
        return ResponseHelper.buildResponse(householdPvApiServiceImpl.removeById(sequenceNbr));
    }

    /**
     * 根据sequenceNbr查询
     *
	 * @param sequenceNbr  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "GET",value = "根据sequenceNbr查询单个户用光伏-厂商API haders",  notes = "根据sequenceNbr查询单个户用光伏-厂商API haders")
	public ResponseModel<HouseholdPvApiDto> selectOne(@PathVariable Long sequenceNbr) {
	    return ResponseHelper.buildResponse(householdPvApiServiceImpl.queryBySeq(sequenceNbr));
	}

	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "户用光伏-厂商API haders分页查询",  notes = "户用光伏-厂商API haders分页查询")
	public ResponseModel<Page<HouseholdPvApiDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<HouseholdPvApiDto> page = new Page<HouseholdPvApiDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(householdPvApiServiceImpl.queryForHouseholdPvApiPage(page));
	}

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY,needAuth = false)
	@ApiOperation(httpMethod = "GET",value = "户用光伏-厂商API haders列表全部数据查询",   notes = "户用光伏-厂商API haders列表全部数据查询")
	@GetMapping(value = "/list")
	public ResponseModel<List<HouseholdPvApiDto>> selectForList() {
	    return ResponseHelper.buildResponse(householdPvApiServiceImpl.queryForHouseholdPvApiList());
	}
}
