package com.yeejoin.amos.api.openapi.face.model;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import org.typroject.tyboot.core.rdbms.model.BaseModel;

/**
* 企业数据信息Vo
*
* @author duanwei
* @date 2022-07-20
*/
@EqualsAndHashCode(callSuper = true)
@Data
public class EnterpriseInfoModel extends AbstractBaseModel {

    private static final long serialVersionUID = 1L;


    private String superviseOrgCode;
    private String superviseOrgName;

    private List businessLicense;

            @ApiModelProperty(value = "使用单位唯一标识")
    /**
    * 使用单位唯一标识
    */
    private String useUnitCode;
            @ApiModelProperty(value = "监管系统唯一编码")
    /**
    * 监管系统唯一编码
    */
    private String superviseCode;
            @ApiModelProperty(value = "使用单位证件类型")
    /**
    * 使用单位证件类型
    */
    private String useUnitCertificate;
            @ApiModelProperty(value = "使用单位代码")
    /**
    * 使用单位代码
    */
    private String useCode;
            @ApiModelProperty(value = "使用单位名称")
    /**
    * 使用单位名称
    */
    private String useUnit;
            @ApiModelProperty(value = "是否重点监控单位")
    /**
    * 是否重点监控单位
    */
    private String keyUnit;
            @ApiModelProperty(value = "重点场所分类")
    /**
    * 重点场所分类
    */
    private String classPlaces;
            @ApiModelProperty(value = "单位所在省份名称")
    /**
    * 单位所在省份名称
    */
    private String province;
            @ApiModelProperty(value = "单位所在城市名称")
    /**
    * 单位所在城市名称
    */
    private String city;
            @ApiModelProperty(value = "单位所在区县名称")
    /**
    * 单位所在区县名称
    */
    private String district;
            @ApiModelProperty(value = "单位所在街道名称")
    /**
    * 单位所在街道名称
    */
    private String street;
            @ApiModelProperty(value = "单位所在社区名称")
    /**
    * 单位所在社区名称
    */
    private String community;
            @ApiModelProperty(value = "单位详细地址")
    /**
    * 单位详细地址
    */
    private String address;
            @ApiModelProperty(value = "使用单位法人")
    /**
    * 使用单位法人
    */
    private String legalPerson;
            @ApiModelProperty(value = "法人联系电话")
    /**
    * 法人联系电话
    */
    private String legalPhone;
            @ApiModelProperty(value = "使用单位联系人")
    /**
    * 使用单位联系人
    */
    private String useContact;
            @ApiModelProperty(value = "联系人联系电话")
    /**
    * 联系人联系电话
    */
    private String contactPhone;
            @ApiModelProperty(value = "安全管理人员1姓名")
    /**
    * 安全管理人员1姓名
    */
    private String safetyOne;
            @ApiModelProperty(value = "安全管理人员1身份证")
    /**
    * 安全管理人员1身份证
    */
    private String safetyOneId;
            @ApiModelProperty(value = "安全管理人员1联系电话")
    /**
    * 安全管理人员1联系电话
    */
    private String safetyOnePhone;
            @ApiModelProperty(value = "安全管理人员2")
    /**
    * 安全管理人员2
    */
    private String safetyTwo;
            @ApiModelProperty(value = "安全管理人员2身份证")
    /**
    * 安全管理人员2身份证
    */
    private String safetyTwoId;
            @ApiModelProperty(value = "安全管理人员2联系电话")
    /**
    * 安全管理人员2联系电话
    */
    private String safetyTwoPhone;
            @ApiModelProperty(value = "单位地理坐标经度")
    /**
    * 单位地理坐标经度
    */
    private String longitude;
            @ApiModelProperty(value = "单位地理坐标纬度")
    /**
    * 单位地理坐标纬度
    */
    private String latitude;


}
