package com.yeejoin.amos.api.openapi.face.model;

import com.alibaba.fastjson.annotation.JSONField;
import lombok.Data;
import lombok.EqualsAndHashCode;


@EqualsAndHashCode(callSuper = true)
@Data
public class TmCylinderFillingModel extends AbstractBaseModel{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private String sequenceCode;	//气瓶唯一标识码*
	private String fillingUnitName;	//充装企业名称*
	private String inspectorUser;	//检查人员姓名*
	private String inspectionDate;	//检查时间*
	private String creditCode;	//统一社会信用代码
	private String isValid;	//是否在检验有效期以内，严禁充装超期未检气瓶、非法改装或翻新及报废气瓶
	private int same;	//警示标签上印有的瓶装气体的名称及化学分子式应与气瓶钢印标志是否一致*
	private int isRegulations;	//气瓶外表面的颜色标志是否符合规定*
	@JSONField(name = "isComplianceWithGBT")
	private int isComplianceWithgbt;	//气瓶瓶阀的出气口螺纹型式是否符合GB/T15383的规定，即可燃气体用的瓶阀，出口螺纹应是内螺纹（左旋）*
	private int haveStillPressure;	//气瓶内有无剩余压力*
	private int isComplete;	//气瓶外表面有无裂纹、严重腐蚀、明显变形及其他严重外部损伤缺陷*
	private int haveSecurityDocuments;	//气瓶的安全附件齐全并符合安全要求
	private String fillBeforeItem;	//	新投入使用气瓶或经检验后首次投入使用气瓶，充装前应按照规定先置换瓶内空气，并经分析合格后方可充气
	private String checkResults;	//检查结果
	private String nonconformances;	//不合格项
	/**
	 * 充装前检查id
	 */
	private String fillingBeforeId;





}
