package com.yeejoin.amos.api.openapi.face.orm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * <p>
 * 单位信息
 * </p>
 *
 * @author 子杨
 * @since 2021-12-17
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("tm_special_unit")
public class SpecialUnit extends AbstractBaseEntity {

	private static final long serialVersionUID = 1L;
	/**
	 * 单位ID
	 */
	@TableField("unit_id")
	private String unitId;
	/**
	 * 单位名称
	 */
	@TableField("unit_name")
	private String unitName;
	/**
	 * 社会统一信用代码
	 */
	@TableField("credit_code")
	private String creditCode;
	/**
	 * 单位类型
	 */
	@TableField("unit_type")
	private String unitType;
	/**
	 * 地区代码
	 */
	@TableField("region_code")
	private String regionCode;
	/**
	 * 邮政编码
	 */
	@TableField("postal_code")
	private String postalCode;
	/**
	 * 单位详细地址
	 */
	@TableField("address")
	private String address;
	/**
	 * 法定代表人
	 */
	@TableField("legal_representative")
	private String legalRepresentative;
	/**
	 * 法人联系电话
	 */
	@TableField("legal_phone")
	private String legalPhone;
	/**
	 * 单位电话
	 */
	@TableField("unit_phone")
	private String unitPhone;
	/**
	 * 单位传真
	 */
	@TableField("unit_fax")
	private String unitFax;
	/**
	 * 电子邮箱
	 */
	@TableField("email")
	private String email;
	/**
	 * 单位网址
	 */
	@TableField("unit_website")
	private String unitWebsite;
	/**
	 * 联系人
	 */
	@TableField("contacts")
	private String contacts;
	/**
	 * 联系人电话
	 */
	@TableField("Contacts_phone")
	private String contactsPhone;
	/**
	 * 安全管理部门
	 */
	@TableField("safe_manage_org")
	private String safeManageOrg;
	/**
	 * 安全管理人员
	 */
	@TableField("safe_manage_people")
	private String safeManagePeople;
	/**
	 * 安管人员联系电话
	 */
	@TableField("safe_manage_people_phone")
	private String safeManagePeoplePhone;

}
