package com.yeejoin.amos.api.openapi.face.orm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.lang.reflect.Method;

/**
 * 气瓶检验信息
 *
 * @author kinky
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("tm_cylinder_inspection")
public class TmCylinderInspection extends AbstractBaseEntity {

    private static final long serialVersionUID = 1L;
    @TableField("scrap_quantity")
    private String scrapQuantity;    //不合格报废数量
    @TableField("inspection_unit")
    private String inspectionUnit;    //检验单位*
    @TableField("sequence_code")
    private String sequenceCode;    //气瓶唯一标识码*
    @TableField("inspection_date")
    private String inspectionDate;    //检验日期*
    @TableField("next_inspection_date")
    private String nextInspectionDate;    //下次检验日期*
    @TableField("inspection_result")
    private String inspectionResult;    //检验结果*

    @ApiModelProperty(value = "对接接口版本")
    protected String version = "v1";

}
