package com.yeejoin.amos.api.openapi.face.orm.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
/**
 * 气瓶企业信息
 * @author kinky
 *
 */
@EqualsAndHashCode(callSuper = true)
@Data
@TableName("tm_cylinder_unit")
public class TmCylinderUnit extends AbstractBaseEntity{/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	@TableField("unit_id")
	private String unitId;	//单位ID
	@TableField("region_code")
	private String regionCode;	//所属区域
	@TableField("unit_name")
	private String unitName;	//单位名称

	@TableField("credit_code")
	private String creditCode;	//统一社会信用代码
	@TableField("address")
	private String address;	//详细地址
	@TableField("unit_person")
	private String unitPerson;	//企业负责人
	@TableField("person_mobile_phone")
	private String personMobilePhone;	//企业负责人手机
	@TableField("person_telephone")
	private String personTelephone;	//企业负责人固定电话
	@TableField("security_adm")
	private String securityAdm;
	@TableField("security_adm_phone")
	private String securityAdmPhone;
	@TableField("postal_code")
	private String postalCode;	//企业邮编

//	@TableField("unit_abbreviation")
//	private String unitAbbreviation;	//企业简称
//	@TableField("filling_license")
//	private String fillingLicense;	//充装许可证号
//	@TableField("filling_permit_date")
//	private String fillingPermitDate;	//充装许可证有效期
//	@TableField("filling_perm_scope")
//	private String fillingPermScope;	//充装许可范围
//	@TableField("inspection_license")
//	private String inspectionLicense;	//检验许可证号
//	@TableField("inspection_scope")
//	private String inspectionScope;	//检验范围
//	@TableField("effective_date")
//	private String effectiveDate;	//检验许可证有效期
//	@TableField("manufacturing_license")
//	private String manufacturingLicense;	//制造许可证号
//	@TableField("manufacturing_date")
//	private String manufacturingDate;	//制造许可证有效期
//	@TableField("manufacturing_scope")
//	private String manufacturingScope;	//制造许可范围
//	@TableField("manufacturing_unit_code")
//	private String manufacturingUnitCode;	//制造单位代码

	/**
	 * 所属区域
	 */
	private String regionName;

	@ApiModelProperty(value = "企业资质附件")
	@TableField("qualification_file")
	private String qualificationFile;

	@ApiModelProperty(value = "使用登记证附件")
	@TableField("use_register_file")
	private String useRegisterFile;

	@ApiModelProperty(value = "设备汇总表附件")
	@TableField("device_summary_file")
	private String deviceSummaryFile;

	@ApiModelProperty(value = "对接接口版本")
	protected String version = "v1";
}
