package com.yeejoin.amos.api.openapi.face.service;

import java.util.Date;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.typroject.tyboot.component.cache.Redis;
import org.typroject.tyboot.core.foundation.context.RequestContext;
import org.typroject.tyboot.core.foundation.utils.ValidationUtil;
import org.typroject.tyboot.core.rdbms.service.BaseService;
import org.typroject.tyboot.core.restful.exception.instance.BadRequest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.api.openapi.constant.Constant;
import com.yeejoin.amos.api.openapi.face.model.BizTokenModel;
import com.yeejoin.amos.api.openapi.face.model.SpecialBoilerModel;
import com.yeejoin.amos.api.openapi.face.orm.dao.SpecialBoilerMapper;
import com.yeejoin.amos.api.openapi.face.orm.entity.SpecialBoiler;

/**
 * <p>
 * 锅炉 服务类
 * </p>
 *
 * @author 子杨
 * @since 2021-12-17
 */
@Component
public class SpecialBoilerService extends  BaseService<SpecialBoilerModel, SpecialBoiler, SpecialBoilerMapper> {

        /**
         * 分页查询
         */
        public Page<SpecialBoilerModel> queryForTmSpecialBoilerPage(Page page, String agencyCode) {
                return this.queryForPage(page, null, false, agencyCode);
        }

        /**
         * 列表查询 示例
         */
        public List<SpecialBoilerModel> queryForTmSpecialBoilerList(String agencyCode) {
                return this.queryForList("", false, agencyCode);
        }
        @Transactional(rollbackFor= {Exception.class})
		public String createSpecialBoiler(List<SpecialBoilerModel> model) {
			// TODO Auto-generated method stub
			if (ValidationUtil.isEmpty(model))
				throw new BadRequest("锅炉信息数据为空.");
	    	
			for (SpecialBoilerModel specialBoilerModel : model) {
				specialBoilerModel.setRecDate(new Date());
				specialBoilerModel.setAppId(getAppId());
				this.createWithModel(specialBoilerModel);
			}
			return "OK";
		}
		private String getAppId() {
			String tokenKey = Redis.genKey(Constant.TOKEN_PREFIX,RequestContext.getToken());
	    	BizTokenModel bizTokenModel = (BizTokenModel) redisTemplate.opsForValue().get(tokenKey);
	    	return bizTokenModel.getAppId();
		}
	    @Autowired
	    private RedisTemplate redisTemplate;
}
