package com.yeejoin.amos.boot.module.elevator.biz.controller;

import com.yeejoin.amos.boot.biz.common.annotation.ResubmitCheck;
import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import java.util.List;
import com.yeejoin.amos.boot.module.elevator.biz.service.impl.EquipmentRegionNumServiceImpl;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.elevator.api.dto.EquipmentRegionNumDto;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 设备区域数量中间表
 *
 * @author system_generator
 * @date 2021-11-09
 */
@RestController
@Api(tags = "设备区域数量中间表Api")
@RequestMapping(value = "/equipment-region-num")
public class EquipmentRegionNumController extends BaseController {

    @Autowired
    EquipmentRegionNumServiceImpl equipmentRegionNumServiceImpl;

    /**
     * 新增设备区域数量中间表
     *
     * @return
     */
	@ResubmitCheck
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增设备区域数量中间表", notes = "新增设备区域数量中间表")
	public ResponseModel<EquipmentRegionNumDto> save(@RequestBody EquipmentRegionNumDto model) {
	    model = equipmentRegionNumServiceImpl.createWithModel(model);
	    return ResponseHelper.buildResponse(model);
	}

	/**
     * 根据sequenceNbr更新
     *
     * @param sequenceNbr 主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "根据sequenceNbr更新设备区域数量中间表", notes = "根据sequenceNbr更新设备区域数量中间表")
	public ResponseModel<EquipmentRegionNumDto> updateBySequenceNbrEquipmentRegionNum(@RequestBody EquipmentRegionNumDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr) {
	    model.setSequenceNbr(sequenceNbr);
	    return ResponseHelper.buildResponse(equipmentRegionNumServiceImpl.updateWithModel(model));
	}

	/**
     * 根据sequenceNbr删除
     *
     * @param sequenceNbr 主键
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @DeleteMapping(value = "/{sequenceNbr}")
    @ApiOperation(httpMethod = "DELETE", value = "根据sequenceNbr删除设备区域数量中间表", notes = "根据sequenceNbr删除设备区域数量中间表")
    public ResponseModel<Boolean> deleteBySequenceNbr(HttpServletRequest request, @PathVariable(value = "sequenceNbr") Long sequenceNbr){
        return ResponseHelper.buildResponse(equipmentRegionNumServiceImpl.removeById(sequenceNbr));
    }

    /**
     * 根据sequenceNbr查询
     *
	 * @param sequenceNbr  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "GET",value = "根据sequenceNbr查询单个设备区域数量中间表",  notes = "根据sequenceNbr查询单个设备区域数量中间表")
	public ResponseModel<EquipmentRegionNumDto> selectOne(@PathVariable Long sequenceNbr) {
	    return ResponseHelper.buildResponse(equipmentRegionNumServiceImpl.queryBySeq(sequenceNbr));
	}

	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "设备区域数量中间表分页查询",  notes = "设备区域数量中间表分页查询")
	public ResponseModel<Page<EquipmentRegionNumDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<EquipmentRegionNumDto> page = new Page<EquipmentRegionNumDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(equipmentRegionNumServiceImpl.queryForEquipmentRegionNumPage(page));
	}

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "设备区域数量中间表列表全部数据查询",   notes = "设备区域数量中间表列表全部数据查询")
	@GetMapping(value = "/list")
	public ResponseModel<List<EquipmentRegionNumDto>> selectForList() {
	    return ResponseHelper.buildResponse(equipmentRegionNumServiceImpl.queryForEquipmentRegionNumList());
	}
}
