package com.yeejoin.amos.boot.module.app.api.dto;

import com.yeejoin.amos.boot.biz.common.dto.BaseDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * 使用信息表
 *
 * @author cpp
 * @date 2023-04-06 15:21:21
 */
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="UseInfo", description="使用信息")
public class UseInfoModel extends BaseDto {
    private static final long serialVersionUID = 1L;

    

    @ApiModelProperty(value = "")
    private String instanceId;
    @ApiModelProperty(value = "")
    private String status;
    @ApiModelProperty(value = "使用单位统一信用代码")
    private String useUnitCreditCode;
    @ApiModelProperty(value = "使用单位名称")
    private String useUnitName;
    @ApiModelProperty(value = "产权单位统一信用代码")
    private String estateUnitCreditCode;
    @ApiModelProperty(value = "产权单位名称")
    private String estateUnitName;
    @ApiModelProperty(value = "使用状态变更日期")
    private String useStateChangeDate;
    @ApiModelProperty(value = "变更事项")
    private String changes;
    @ApiModelProperty(value = "使用内部编号")
    private String useInnerCode;
    @ApiModelProperty(value = "投入使用日期")
    private String useDate;
    @ApiModelProperty(value = "经办人")
    private String agent;
    @ApiModelProperty(value = "设备使用地点-省")
    private String province;
    @ApiModelProperty(value = "设备使用地点-市")
    private String city;
    @ApiModelProperty(value = "设备使用地点-区（县）")
    private String county;
    @ApiModelProperty(value = "设备使用地点-街道（镇）")
    private String factoryUseSiteStreet;
    @ApiModelProperty(value = "设备详细使用地址")
    private String address;
    @ApiModelProperty(value = "设备地理坐标经纬度")
    private String longitudeLatitude;
    @ApiModelProperty(value = "设备使用场所")
    private String usePlace;
    @ApiModelProperty(value = "设备主管部门")
    private String equManageDt;
    @ApiModelProperty(value = "安全管理部门名称")
    private String safetyManageDt;
    @ApiModelProperty(value = "安全管理员")
    private String safetyManager;
    @ApiModelProperty(value = "安全管理员移动电话")
    private String phone;
    @ApiModelProperty(value = "设备状态")
    private String equState;
    @ApiModelProperty(value = "")
    private String provinceName;
    @ApiModelProperty(value = "")
    private String cityName;
    @ApiModelProperty(value = "")
    private String countyName;

}
