package com.yeejoin.amos.boot.module.common.api.dto;

import com.yeejoin.amos.boot.biz.common.dto.BaseDto;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.util.Date;
import java.util.List;
import java.util.Map;
/**
* 消防员合同
*
* @author tb
* @date 2021-06-07
*/
@Data
@EqualsAndHashCode(callSuper = true)
@ApiModel(value="FirefightersContractDto", description="消防员合同")
public class FirefightersContractDto extends BaseDto {
    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "合同名称")
    private String name;

    @ApiModelProperty(value = "甲方")
    private String partyA;

    @ApiModelProperty(value = "乙方")
    private String partyB;

    @ApiModelProperty(value = "签订日期")
    private Date signedTime;

    @ApiModelProperty(value = "到期时间")
    private Date expireTime;
    
    @ApiModelProperty(value = "起始时间")
    private Date startTime;

    @ApiModelProperty(value = "服务内容")
    private String serviceContent;

    @ApiModelProperty(value = "合同附件")
    private String attachment;

    @ApiModelProperty(value = "合同类型")
    private String contractType;

    @ApiModelProperty(value = "人员id")
    private Long firefightersId;

    @ApiModelProperty(value = "更新时间")
    private Date updateTime;

    @ApiModelProperty(value = "操作人名称")
    private String recUserName;
    
    @ApiModelProperty(value = "附件")
    private Map<String, List<AttachmentDto>> attachments;

    @ApiModelProperty(value = "合同类型字典code")
    private String contractTypeCode;

}
