package com.yeejoin.amos.boot.module.cylinder.biz.controller;

import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import java.util.List;
import com.yeejoin.amos.boot.module.cylinder.biz.service.impl.BaseUnitLicenceServiceImpl;
import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yeejoin.amos.boot.module.cylinder.api.dto.BaseUnitLicenceDto;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 单位注册许可信息表
 *
 * @author system_generator
 * @date 2022-08-09
 */
@RestController
@Api(tags = "单位注册许可信息表Api")
@RequestMapping(value = "/base-unit-licence")
public class BaseUnitLicenceController extends BaseController {

    @Autowired
    BaseUnitLicenceServiceImpl baseUnitLicenceServiceImpl;

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "单位注册许可信息表列表全部数据查询",   notes = "单位注册许可信息表列表全部数据查询")
	@GetMapping(value = "/{unitCode}/list")
	public ResponseModel<List<BaseUnitLicenceDto>> selectForList(@PathVariable String unitCode) {
	    return ResponseHelper.buildResponse(baseUnitLicenceServiceImpl.queryForBaseUnitLicenceList(unitCode));
	}
}
