package com.yeejoin.amos.boot.module.jczs.api.service;


import com.yeejoin.amos.boot.module.jczs.api.dto.RescueProcessDto;
import com.yeejoin.amos.feign.privilege.model.AgencyUserModel;

/**
 * 救援过程表接口类
 *
 * @author kongfm
 * @date 2021-08-03
 */
public interface IRescueProcessService {

    /**
     * 根据警情id 创建救援过程表 或者获取 救援过程表
     * @param alertId
     * @return
     */
    RescueProcessDto getProcessByAlertId(Long alertId);

    /**
     * 根据警情id 更新救援过程表
     * @param rescueProcessDto
     * @return
     */
    Boolean updateByAlertId(RescueProcessDto rescueProcessDto, AgencyUserModel sendUser);

    /**
     * 根据警情id 更新救援过程表
     * @param rescueProcessDto
     * @return
     */
    Boolean updateByAlertId(RescueProcessDto rescueProcessDto);

}
