package com.yeejoin.amos.boot.module.jg.api.mapper;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.jg.api.dto.CompanyEquipCountDto;
import com.yeejoin.amos.boot.module.jg.api.dto.JgInstallationNoticeDto;
import com.yeejoin.amos.boot.module.jg.api.entity.JgInstallationNotice;
import com.yeejoin.amos.boot.module.jg.api.vo.SortVo;
import com.yeejoin.amos.boot.module.jg.api.vo.tableDataExportVo.InstallationVo;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * Mapper 接口
 *
 * @author system_generator
 * @date 2023-12-12
 */
public interface JgInstallationNoticeMapper extends CustomBaseMapper<JgInstallationNotice> {
    /**
     * 分页查询
     *
     * @param page    分页对象
     * @param model   查询参数
     * @param type    类型：enterprise-企业端、supervision-监管端
     * @param orgCode 公司的orgCode
     * @param client 使用类型
     * @return 安装告知列表
     */
    Page<Map<String, Object>> queryForPage(Page<JgInstallationNotice> page,
                                           @Param("param") JgInstallationNoticeDto model,
                                           @Param("type") String type,
                                           @Param("sort") SortVo sort,
                                           @Param("companyCode") String companyCode,
                                           @Param("orgCode") String orgCode,
                                           @Param("client") String client);

    /**
     * 根据安装告知编号查询设备、设计、制造等信息
     *
     * @param sequenceNbr 安装告知编号
     */
    @MapKey("sequenceNbr")
    List<Map<String, Object>> queryEquipInformation(@Param("sequenceNbr") long sequenceNbr);

    List<CompanyEquipCountDto> queryForFlowingEquipList();

    List<InstallationVo> queryInstallationInIds(@Param("ids") List<String> ids);

    List<Map<String, Object>> getDeviceListByProjectContraption(@Param("projectContraptionSeq") String projectContraptionSeq);

    List<Map<String, Object>> getPipelineEquInfoByRecords(@Param("records") List<String> records);

    /**
     * 安装使用登记查询关联的安装告知
     * @param useRegisterId 使用登记id
     * @return 登记关联的告知
     */
    JgInstallationNotice selectNoticeDataByUseRegisterId(@Param("useRegisterId") String useRegisterId );

    /**
     *
     * 查询按照告知已完成但是未生成装置的施工信息的安装告知单据
     * @return 已完成但是未生成装置的施工信息的安装告知单据列表
     */
    List<JgInstallationNotice> selectNotInsertProjectConstructionInstallNoticeList();
}
