package com.yeejoin.amos.boot.module.tcm.api.entity;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.math.BigDecimal;

/**
 * 安全追溯-起重机械
 * 
 * @author cpp
 * @date 2023-04-06 15:21:22
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("idx_biz_jg_tech_params_lifting")
public class EquipTechParamLifting extends AbstractEquipBaseEntity {
	private static final long serialVersionUID = 1L;




			/**
  	 *  	 * $column.comments
     *      */

		@TableField(value ="\"INSTANCE_ID\"")
	private String instanceId;
	/**
  	 *  	 * $column.comments
     *      */

		@TableField(value ="\"STATUS\"")
	private String status;
	/**
  	 *  	 * 额定起重量
     *      */

		@TableField(value ="\"RATED_LIFTING_CAPACITY\"")
	private BigDecimal ratedLiftingCapacity;
	/**
  	 *  	 * 最大起重量
     *      */

		@TableField(value ="\"MAX_LIFTING_CAPACITY\"")
	private BigDecimal maxLiftingCapacity;
	/**
  	 *  	 * 最大起重力矩
     *      */

		@TableField(value ="\"MAX_LIFTING_TORQUE\"")
	private BigDecimal maxLiftingTorque;
	/**
  	 *  	 * 跨度（工作幅度）
     *      */

		@TableField(value ="\"SPAN_WORKING_RANGE\"")
	private BigDecimal spanWorkingRange;
	/**
  	 *  	 * 起升速度
     *      */

		@TableField(value ="\"LIFTING_SPEED\"")
	private BigDecimal liftingSpeed;
	/**
  	 *  	 * 起升高度
     *      */

		@TableField(value ="\"LIFTING_HEIGHT\"")
	private BigDecimal liftingHeight;
	/**
  	 *  	 * 下降速度
     *      */

		@TableField(value ="\"DESCENT_SPEED\"")
	private BigDecimal descentSpeed;
	/**
  	 *  	 * 变幅高度
     *      */

		@TableField(value ="\"LUFFING_HEIGHT\"")
	private BigDecimal luffingHeight;
	/**
  	 *  	 * 回转速度
     *      */

		@TableField(value ="\"SLEWING_SPEED\"")
	private BigDecimal slewingSpeed;
	/**
  	 *  	 * 高度
     *      */

		@TableField(value ="\"HEIGHT\"")
	private BigDecimal height;
	/**
  	 *  	 * 工作级别
     *      */

		@TableField(value ="\"WORK_LEVEL\"")
	private String workLevel;
	/**
  	 *  	 * 额定起重力矩
     *      */

		@TableField(value ="\"RATED_LIFTING_TORQUE\"")
	private BigDecimal ratedLiftingTorque;
	/**
  	 *  	 * 最大起升高度
     *      */

		@TableField(value ="\"MAXI_LIFTING_HEIGHT\"")
	private BigDecimal maxiLiftingHeight;
	/**
  	 *  	 * 最大工作幅度
     *      */

		@TableField(value ="\"MAX_WORK_RANGE\"")
	private BigDecimal maxWorkRange;
	/**
  	 *  	 * 最大工作幅度对应的起重量
     *      */

		@TableField(value ="\"MAX_WOK_RANGE_WEIGHT\"")
	private BigDecimal maxWokRangeWeight;
	/**
  	 *  	 * 最大附着高度
     *      */

		@TableField(value ="\"MAX_ATTACHMENT_HEIGHT\"")
	private BigDecimal maxAttachmentHeight;
	/**
  	 *  	 * 最大计算轮压
     *      */

		@TableField(value ="\"MAX_CALCULATED_PRESSURE\"")
	private BigDecimal maxCalculatedPressure;
	/**
  	 *  	 * 整机设计重量
     *      */

		@TableField(value ="\"MACHINE_DESIGN_WEIGHT\"")
	private BigDecimal machineDesignWeight;
	/**
  	 *  	 * 运行轨距
     *      */

		@TableField(value ="\"RUN_GAUGE\"")
	private BigDecimal runGauge;
	/**
  	 *  	 * 整机功率
     *      */

		@TableField(value ="\"OVERALL_POWER\"")
	private BigDecimal overallPower;
	/**
  	 *  	 * 供电电源
     *      */

		@TableField(value ="\"POWER_SUPPLY\"")
	private BigDecimal powerSupply;
	/**
  	 *  	 * 工作环境温度
     *      */

		@TableField(value ="\"WORK_AMBIENT_TEMPERATURE\"")
	private BigDecimal workAmbientTemperature;
	/**
  	 *  	 * 层数/泊位数
     *      */

		@TableField(value ="\"NUMBER_STOREY\"")
	private Integer numberStorey;
	/**
  	 *  	 * 主体结构型式
     *      */

		@TableField(value ="\"MAIN_STRUCTURE_TYPE\"")
	private String mainStructureType;
	/**
  	 *  	 * 主要受力结构件材料
     *      */

		@TableField(value ="\"MAIN_STRESSED_STRUCTURAL_MATERIAL\"")
	private String mainStressedStructuralMaterial;
	/**
  	 *  	 * 变幅方式
     *      */

		@TableField(value ="\"LUFFING_MODE\"")
	private String luffingMode;
	/**
  	 *  	 * 塔身标准节型式
     *      */

		@TableField(value ="\"TOWER_STANDARD_TYPE\"")
	private String towerStandardType;
	/**
  	 *  	 * 基座型式
     *      */

		@TableField(value ="\"BASE_TYPE\"")
	private String baseType;
	/**
  	 *  	 * 大车运行速度
     *      */

		@TableField(value ="\"BIGCAR_RUN_SPEED\"")
	private BigDecimal bigcarRunSpeed;
	/**
  	 *  	 * 小车运行速度
     *      */

		@TableField(value ="\"SMALLCARRUN_SPEED\"")
	private BigDecimal smallcarrunSpeed;
	/**
  	 *  	 * 大车基距
     *      */

		@TableField(value ="\"BIGCAR_BASE_DISTANCE\"")
	private BigDecimal bigcarBaseDistance;
	/**
  	 *  	 * 小车轨距
     *      */

		@TableField(value ="\"SMALLCAR_BASE_DISTANCE\"")
	private BigDecimal smallcarBaseDistance;
	/**
  	 *  	 * 主钩左右极限位置
     *      */

		@TableField(value ="\"MAIN_HOOK_LEFT_AND_RIGHT_LIMIT_POSITIONS\"")
	private BigDecimal mainHookLeftAndRightLimitPositions;
	/**
  	 *  	 * 主梁型式
     *      */

		@TableField(value ="\"MAIN_BEAM_TYPE\"")
	private String mainBeamType;
	/**
  	 *  	 * 支腿型式
     *      */

		@TableField(value ="\"OUTRIGGER_TYPE\"")
	private String outriggerType;
	/**
  	 *  	 * 最小工作幅度
     *      */

		@TableField(value ="\"MIN_WORK_RANGE\"")
	private BigDecimal minWorkRange;
	/**
  	 *  	 * 最小幅度起重量
     *      */

		@TableField(value ="\"MIN_LIFTING_CAPACITY\"")
	private BigDecimal minLiftingCapacity;
	/**
  	 *  	 * 全程变幅时间
     *      */

		@TableField(value ="\"FULL_RANGE_LUFFING_TIME\"")
	private BigDecimal fullRangeLuffingTime;
	/**
  	 *  	 * 行走机械轨距
     *      */

		@TableField(value ="\"TRAVEL_MACHINE_GAUGE\"")
	private BigDecimal travelMachineGauge;
	/**
  	 *  	 * 行驶速度
     *      */

		@TableField(value ="\"TRAVEL_SPEED\"")
	private BigDecimal travelSpeed;
	/**
  	 *  	 * 支腿调节长度
     *      */

		@TableField(value ="\"LEG_ADJUSTMENT_LENGTH\"")
	private BigDecimal legAdjustmentLength;
	/**
  	 *  	 * 发动机型号/VIN代号/编号
     *      */

		@TableField(value ="\"ENGINE_MODEL\"")
	private String engineModel;
	/**
  	 *  	 * 臂架型式
     *      */

		@TableField(value ="\"BOOM_TYPE\"")
	private String boomType;
	/**
  	 *  	 * 起升高度(轨上)
     *      */

		@TableField(value ="\"LIFTING_HEIGHT_ON_RAIL\"")
	private BigDecimal liftingHeightOnRail;
	/**
  	 *  	 * 起升高度(轨下)
     *      */

		@TableField(value ="\"LIFTING_HEIGHT_UNDER_RAIL\"")
	private BigDecimal liftingHeightUnderRail;
	/**
  	 *  	 * 整机最大高度
     *      */

		@TableField(value ="\"MACHINE_MAX_HEIGHT\"")
	private BigDecimal machineMaxHeight;
	/**
  	 *  	 * 用途
     *      */

		@TableField(value ="\"USE\"")
	private String use;
	/**
  	 *  	 * 臂架结构型式
     *      */

		@TableField(value ="\"BOOM_STRUCTURE_TYPE\"")
	private String boomStructureType;
	/**
  	 *  	 * 门架结构型式
     *      */

		@TableField(value ="\"GANTRY_STRUCTURE_TYPE\"")
	private String gantryStructureType;
	/**
  	 *  	 * 额定载重量
     *      */

		@TableField(value ="\"RATED_LOAD_CAPACITY\"")
	private BigDecimal ratedLoadCapacity;
	/**
  	 *  	 * 额定成员数
     *      */

		@TableField(value ="\"RATED_MEMBERS\"")
	private Integer ratedMembers;
	/**
  	 *  	 * 额定提升速度
     *      */

		@TableField(value ="\"RATED_LIFTING_SPEED\"")
	private BigDecimal ratedLiftingSpeed;
	/**
  	 *  	 * 自由端高度
     *      */

		@TableField(value ="\"HEIGHT_FREE_END\"")
	private BigDecimal heightFreeEnd;
	/**
  	 *  	 * 最大提升高度
     *      */

		@TableField(value ="\"MAXIMUM_LIFTING_HEIGHT\"")
	private BigDecimal maximumLiftingHeight;
	/**
  	 *  	 * 吊笼工作行程
     *      */

		@TableField(value ="\"WORK_STROKE_CAGE\"")
	private BigDecimal workStrokeCage;
	/**
  	 *  	 * 吊笼尺寸(长×宽×高)
     *      */

		@TableField(value ="\"CAGE_SIZE\"")
	private BigDecimal cageSize;
	/**
  	 *  	 * 标准节尺寸(长×宽×高)
     *      */

		@TableField(value ="\"STANDARD_SECTION_SIZE\"")
	private BigDecimal standardSectionSize;
	/**
  	 *  	 * 操纵方式
     *      */

		@TableField(value ="\"CONTROL_MODE\"")
	private String controlMode;
	/**
  	 *  	 * 驱动机构型式
     *      */

		@TableField(value ="\"DRIVE_MECHANISM_TYPE\"")
	private String driveMechanismType;
	/**
  	 *  	 * 标准节加节方式
     *      */

		@TableField(value ="\"STANDARD_SECTION_ADD_METHOD\"")
	private String standardSectionAddMethod;
	/**
  	 *  	 * 存容量
     *      */

		@TableField(value ="\"STORAGE_CAPACITY\"")
	private Integer storageCapacity;
	/**
  	 *  	 * 起升驱动方式
     *      */

		@TableField(value ="\"LIFTING_DRIVE_MODE\"")
	private String liftingDriveMode;
	/**
  	 *  	 * 适停车辆尺寸 (长×宽×高)
     *      */

		@TableField(value ="\"PARKING_VEHICLE_SIZE\"")
	private BigDecimal parkingVehicleSize;
	/**
  	 *  	 * 额定升降速度
     *      */

		@TableField(value ="\"RATED_LIFT_SPEED\"")
	private BigDecimal ratedLiftSpeed;
	/**
  	 *  	 * 额定横移速度
     *      */

		@TableField(value ="\"RATED_TRAVERSE_SPEED\"")
	private BigDecimal ratedTraverseSpeed;
	/**
  	 *  	 * 额定纵移速度
     *      */

		@TableField(value ="\"RATED_LONGITUDINAL_SPEED\"")
	private BigDecimal ratedLongitudinalSpeed;
	/**
  	 *  	 * 单车最大进(出)车时间
     *      */

		@TableField(value ="\"BICYCLE_MAX_EXIT_TIME\"")
	private BigDecimal bicycleMaxExitTime;
	/**
  	 *  	 * 循环速度
     *      */

		@TableField(value ="\"CYCLE_SPEED\"")
	private BigDecimal cycleSpeed;
	/**
  	 *  	 * 适停车辆质量
     *      */

		@TableField(value ="\"PARKING_VEHICLE_MASS\"")
	private BigDecimal parkingVehicleMass;
	/**
  	 *  	 * 层高
     *      */

		@TableField(value ="\"STOREY_HEIGHT\"")
	private BigDecimal storeyHeight;
	/**
  	 *  	 * 操作方式
     *      */

		@TableField(value ="\"OPERATION_MODE\"")
	private String operationMode;
	/**
  	 *  	 * 其 他
     *      */

		@TableField(value ="\"OTHER\"")
	private String other;
	/**
  	 *  	 * 起升方式
     *      */

		@TableField(value ="\"LIFTING_MODE\"")
	private String liftingMode;
	/**
  	 *  	 * 最大轮压
     *      */

		@TableField(value ="\"MAX_PRESSURE\"")
	private BigDecimal maxPressure;
	/**
  	 *  	 * 下降深度
     *      */

		@TableField(value ="\"DEPTH_DESCENT\"")
	private BigDecimal depthDescent;
	/**
  	 *  	 * 防爆等级
     *      */

		@TableField(value ="\"EXPLOSION_PROOF_GRADE\"")
	private String explosionProofGrade;
	/**
  	 *  	 * 防爆型式
     *      */

		@TableField(value ="\"EXPLOSION_PROOF_TYPE\"")
	private String explosionProofType;
	/**
  	 *  	 * 吊具型式
     *      */

		@TableField(value ="\"SLING_TYPE\"")
	private String slingType;
	/**
  	 *  	 * 主要受力机构件材料
     *      */

		@TableField(value ="\"MAIN_STRESSED_MECHANISM\"")
	private String mainStressedMechanism;
	/**
  	 *  	 * 起升机构起升速度倍率
     *      */

		@TableField(value ="\"HOIST_LIFTING_MECHANISM_SPEED\"")
	private BigDecimal hoistLiftingMechanismSpeed;
	/**
  	 *  	 * 起升机构起升速度
     *      */

		@TableField(value ="\"HOIST_LIFTING_SPEED_LIFTING\"")
	private BigDecimal hoistLiftingSpeedLifting;
	/**
  	 *  	 * 起升机构起升速度相应最大起重量
     *      */

		@TableField(value ="\"HOIST_LIFTING_CORRESPONDING_MAX_WEIGHT\"")
	private BigDecimal hoistLiftingCorrespondingMaxWeight;
	/**
  	 *  	 * 起升机构电机型号
     *      */

		@TableField(value ="\"HOIST_MOTOR_MODEL\"")
	private String hoistMotorModel;
	/**
  	 *  	 * 起升机构电机数量
     *      */

		@TableField(value ="\"HOIST_MOTORS_NUMBER\"")
	private Integer hoistMotorsNumber;
	/**
  	 *  	 * 起升机构功率
     *      */

		@TableField(value ="\"HOIST_POWER\"")
	private BigDecimal hoistPower;
	/**
  	 *  	 * 起升机构制动器型号
     *      */

		@TableField(value ="\"HOIST_BRAKE_MODEL\"")
	private String hoistBrakeModel;
	/**
  	 *  	 * 起升机构制动器数量
     *      */

		@TableField(value ="\"HOIST_BRAKES_BRAKES\"")
	private Integer hoistBrakesBrakes;
	/**
  	 *  	 * 起升机构工作级别
     *      */

		@TableField(value ="\"HOIST_WORKING_LEVEL\"")
	private String hoistWorkingLevel;
	/**
  	 *  	 * 起升机构卷筒直径
     *      */

		@TableField(value ="\"HOIST_DRUM_DIAMETER\"")
	private BigDecimal hoistDrumDiameter;
	/**
  	 *  	 * 起升机构定滑轮直径
     *      */

		@TableField(value ="\"HOIST_FIXED_PULLEY_DIAMETER\"")
	private BigDecimal hoistFixedPulleyDiameter;
	/**
  	 *  	 * 起升机构传动比
     *      */

		@TableField(value ="\"HOIST_TRANSMISSION_RATIO\"")
	private String hoistTransmissionRatio;
	/**
  	 *  	 * 起升机构大车轮直径
     *      */

		@TableField(value ="\"HOIST_BIGCAR_DIAMETER\"")
	private BigDecimal hoistBigcarDiameter;
	/**
  	 *  	 * 起升机构小车轮直径
     *      */

		@TableField(value ="\"HOIST_SMALLCAR_DIAMETER\"")
	private BigDecimal hoistSmallcarDiameter;
	/**
  	 *  	 * 大车行走机构速度
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_SPEED\"")
	private BigDecimal bigcarTraveSpeed;
	/**
  	 *  	 * 大车行走机构功率
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_POWER\"")
	private BigDecimal bigcarTravePower;
	/**
  	 *  	 * 大车行走机构工作级别
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_WORKING_LEVEL\"")
	private String bigcarTraveWorkingLevel;
	/**
  	 *  	 * 大车行走机构减速器型号
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_REDUCER_MODEL\"")
	private String bigcarTraveReducerModel;
	/**
  	 *  	 * 大车行走机构传动比
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_TRANSMISSION_RATIO\"")
	private String bigcarTraveTransmissionRatio;
	/**
  	 *  	 * 大车行走机构制动力矩
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_BRAK_TORQUE\"")
	private BigDecimal bigcarTraveBrakTorque;
	/**
  	 *  	 * 大车行走机构大车车轮路面直径
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_ROAD_DIAMETER\"")
	private BigDecimal bigcarTraveRoadDiameter;
	/**
  	 *  	 * 大车行走机构适应轨道
     *      */

		@TableField(value ="\"BIG_TRAVE_ADAPT_TRACK\"")
	private String bigTraveAdaptTrack;
	/**
  	 *  	 * 大车行走机构电机型号
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_MOTOR_MODEL\"")
	private String bigcarTraveMotorModel;
	/**
  	 *  	 * 大车行走机构电机数量
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_MOTOR_QUANTITY\"")
	private Integer bigcarTraveMotorQuantity;
	/**
  	 *  	 * 大车行走机构制动器型号
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_CONTROL_BRAKE_MODEL\"")
	private String bigcarTraveControlBrakeModel;
	/**
  	 *  	 * 大车行走机构制动器数量
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_BRAKE_NUMBER\"")
	private Integer bigcarTraveBrakeNumber;
	/**
  	 *  	 * 小车行走机构速度
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_SPEED\"")
	private BigDecimal smallcarTraveSpeed;
	/**
  	 *  	 * 小车行走机构功率
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_POWER\"")
	private BigDecimal smallcarTravePower;
	/**
  	 *  	 * 小车行走机构转速
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_REVOLVE_SPEED\"")
	private BigDecimal smallcarTraveRevolveSpeed;
	/**
  	 *  	 * 小车行走机构工作级别
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_WORKING_LEVEL\"")
	private String smallcarTraveWorkingLevel;
	/**
  	 *  	 * 小车行走机构减速器型号
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_REDUCER_MODEL\"")
	private String smallcarTraveReducerModel;
	/**
  	 *  	 * 小车行走机构传动比
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_TRANSMISSION_RATIO\"")
	private String smallcarTraveTransmissionRatio;
	/**
  	 *  	 * 小车行走机构制动力矩
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_BRAK_TORQUE\"")
	private BigDecimal smallcarTraveBrakTorque;
	/**
  	 *  	 * 小车行走机构小车车轮路面直径
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_ROAD_DIAMETER\"")
	private BigDecimal smallcarTraveRoadDiameter;
	/**
  	 *  	 * 小车行走机构小车轨道
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_TROLLEY_TRACK\"")
	private String smallcarTraveTrolleyTrack;
	/**
  	 *  	 * 小车行走机构电机型号
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_MOTOR_MODEL\"")
	private String smallcarTraveMotorModel;
	/**
  	 *  	 * 小车行走机构电机数量
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_MOTOR_QUANTITY\"")
	private Integer smallcarTraveMotorQuantity;
	/**
  	 *  	 * 小车行走机构制动器型号
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_CONTROL_BRAKE_MODEL\"")
	private String smallcarTraveControlBrakeModel;
	/**
  	 *  	 * 小车行走机构制动器数量
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_BRAKE_NUMBER\"")
	private Integer smallcarTraveBrakeNumber;
	/**
  	 *  	 * 电源电压
     *      */

		@TableField(value ="\"SUPPLY_VOLTAGE\"")
	private BigDecimal supplyVoltage;
	/**
  	 *  	 * 电源频率
     *      */

		@TableField(value ="\"POWER_FREQUENCY\"")
	private BigDecimal powerFrequency;
	/**
  	 *  	 * 非工作风压
     *      */

		@TableField(value ="\"NO_WORK_WIND_PRESSSURE\"")
	private BigDecimal noWorkWindPresssure;
	/**
  	 *  	 * 工作风压
     *      */

		@TableField(value ="\"WORK_WIND_PRESSSURE\"")
	private BigDecimal workWindPresssure;
	/**
  	 *  	 * 环境温度
     *      */

		@TableField(value ="\"AMBIENT_TEMPERATURE\"")
	private BigDecimal ambientTemperature;
	/**
  	 *  	 * 吊钩部位辐射温度
     *      */

		@TableField(value ="\"RADIATION_TEMPERATURE_OF_HOOK\"")
	private BigDecimal radiationTemperatureOfHook;
	/**
  	 *  	 * 梁架跨度
     *      */

		@TableField(value ="\"BEAM_FRAME_SPAN\"")
	private BigDecimal beamFrameSpan;
	/**
  	 *  	 * 桥机跨度
     *      */

		@TableField(value ="\"BRIDGE_CRANE_SPAN\"")
	private BigDecimal bridgeCraneSpan;
	/**
  	 *  	 * 最大架设纵坡
     *      */

		@TableField(value ="\"MAX_ERECTION_LONGITUDINAL_SLOPE\"")
	private BigDecimal maxErectionLongitudinalSlope;
	/**
  	 *  	 * 前支腿调节长度
     *      */

		@TableField(value ="\"ADJUSTABLE_LENGTH_OF_FRONT_OUTRIGGER\"")
	private BigDecimal adjustableLengthOfFrontOutrigger;
	/**
  	 *  	 * 最大架设横坡
     *      */

		@TableField(value ="\"MAX_ERECTION_CROSS_SLOPE\"")
	private BigDecimal maxErectionCrossSlope;
	/**
  	 *  	 * 整机高度
     *      */

		@TableField(value ="\"OVERALL_HEIGHT\"")
	private BigDecimal overallHeight;
	/**
  	 *  	 * 整机宽度
     *      */

		@TableField(value ="\"OVERALL_WIDTH\"")
	private BigDecimal overallWidth;
	/**
  	 *  	 * 整机总功率
     *      */

		@TableField(value ="\"OVERALL_UNIT_POWER\"")
	private BigDecimal overallUnitPower;
	/**
  	 *  	 * 小车纵移速度
     *      */

		@TableField(value ="\"SMALLCAR_LONGITUDINAL_MOVING_SPEED\"")
	private BigDecimal smallcarLongitudinalMovingSpeed;
	/**
  	 *  	 * 过孔速度
     *      */

		@TableField(value ="\"THROUGH_HOLE_VELOCITY\"")
	private BigDecimal throughHoleVelocity;
	/**
  	 *  	 * 整机横移速度
     *      */

		@TableField(value ="\"OVERALL_TRAVERSE_SPEED\"")
	private BigDecimal overallTraverseSpeed;
	/**
  	 *  	 * 小车横移速度
     *      */

		@TableField(value ="\"SMALLCAR_TRAVERSE_SPEED\"")
	private BigDecimal smallcarTraverseSpeed;
	/**
  	 *  	 * 整机长度
     *      */

		@TableField(value ="\"OVERALL_LENGTH\"")
	private BigDecimal overallLength;
	/**
  	 *  	 * 前导梁长度
     *      */

		@TableField(value ="\"LENGTH_OF_FRONT_GUIDE_BEAM\"")
	private BigDecimal lengthOfFrontGuideBeam;
	/**
  	 *  	 * 起升机构减速器型号
     *      */

		@TableField(value ="\"HOIST_REDUCER_MODEL\"")
	private String hoistReducerModel;
	/**
  	 *  	 * 大车行走适应轨道
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_ADAPTATION_TRACK\"")
	private String bigcarTraveAdaptationTrack;
	/**
  	 *  	 * 大车行走制动器型号
     *      */

		@TableField(value ="\"BIGCAR_TRAVE_BRAKE_MODEL\"")
	private String bigcarTraveBrakeModel;
	/**
  	 *  	 * 小车行走机构小车车轮踏面直径
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_SMALL_TREAD_DIAMETER\"")
	private BigDecimal smallcarTraveSmallTreadDiameter;
	/**
  	 *  	 * 小车行走机构制动器型号
     *      */

		@TableField(value ="\"SMALLCAR_TRAVE_BRAKE_MODEL\"")
	private String smallcarTraveBrakeModel;
	/**
  	 *  	 * 小车横移机构速度
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_SPEED\"")
	private BigDecimal smallcarSideswaySpeed;
	/**
  	 *  	 * 小车横移机构功率
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_POWER\"")
	private BigDecimal smallcarSideswayPower;
	/**
  	 *  	 * 小车横移机构转速
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_REVOLVE_SPEED\"")
	private BigDecimal smallcarSideswayRevolveSpeed;
	/**
  	 *  	 * 小车横移机构工作级别
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_WORKING_LEVEL\"")
	private String smallcarSideswayWorkingLevel;
	/**
  	 *  	 * 小车横移机构减速器型号
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_REDUCER_MODEL\"")
	private String smallcarSideswayReducerModel;
	/**
  	 *  	 * 小车横移机构传动比
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_TRANSMISSION_RATIO\"")
	private String smallcarSideswayTransmissionRatio;
	/**
  	 *  	 * 小车横移机构小车横移轨道
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_SMALL_TRAVERSE_TRACK\"")
	private String smallcarSideswaySmallTraverseTrack;
	/**
  	 *  	 * 小车横移机构制动器型号
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_BRAKE_MODEL\"")
	private String smallcarSideswayBrakeModel;
	/**
  	 *  	 * 小车横移机构制动力矩
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_BRAK_TORQUE\"")
	private BigDecimal smallcarSideswayBrakTorque;
	/**
  	 *  	 * 小车横移机构小车横移车轮踏面直径
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_TREAD_DIAMETER\"")
	private BigDecimal smallcarSideswayTreadDiameter;
	/**
  	 *  	 * 小车横移机构电机型号
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_MOTOR_QUANTITY\"")
	private String smallcarSideswayMotorQuantity;
	/**
  	 *  	 * 小车横移机构电机数量
     *      */

		@TableField(value ="\"SMALLCAR_SIDESWAY_MOTOR_NUMBER\"")
	private Integer smallcarSideswayMotorNumber;
	/**
  	 *  	 * 悬臂长度
     *      */

		@TableField(value ="\"CANTILEVER_LENGTH\"")
	private BigDecimal cantileverLength;
	/**
  	 *  	 * 使用场所
     *      */

		@TableField(value ="\"PLACE_USE\"")
	private String placeUse;
	/**
  	 *  	 * 变幅速度
     *      */

		@TableField(value ="\"DERRICKING_SPEED\"")
	private BigDecimal derrickingSpeed;
	/**
  	 *  	 * 最大幅度起重量
     *      */

		@TableField(value ="\"MAXIMUM_LIFTING_CAPACITY\"")
	private BigDecimal maximumLiftingCapacity;
	/**
  	 *  	 * 导轨架
     *      */

		@TableField(value ="\"GUIDE_RAIL_FRAME\"")
	private String guideRailFrame;
	/**
  	 *  	 * 层数
     *      */

		@TableField(value ="\"NUMBER_OF_PLIES\"")
	private Integer numberOfPlies;
	/**
  	 *  	 * 整机重量
     *      */

		@TableField(value ="\"OPERATING_WEIGHT\"")
	private BigDecimal operatingWeight;
	/**
  	 *  	 * 起升机构制动力矩
     *      */

		@TableField(value ="\"HOIST_BRAKING_TORQUE\"")
	private BigDecimal hoistBrakingTorque;
	/**
  	 *  	 * 起升机构钢丝绳型号
     *      */

		@TableField(value ="\"HOIST_WIRE_ROPE\"")
	private String hoistWireRope;
	/**
  	 *  	 * 吊笼数量
     *      */

		@TableField(value ="\"HANGING_CAGES_NUMBER\"")
	private String hangingCagesNumber;

	/**
  	 *  	 * 安全保护装置
     *      */

		@TableField(value ="\"SAFETY_PROTECTION_DEVICE\"")
	private String safetyProtectionDevice;
	/**
  	 *  	 * 主要零部件
     *      */

		@TableField(value ="\"MAIN_PART\"")
	private String mainPart;


}
