package com.yeejoin.amos.patrol.business.param;

import lombok.Data;

/**
 * @author keyong
 * @title: LatentDangerNormalParam
 * <pre>
 * @description: 隐患
 * </pre>
 * @date 2021/1/26 14:46
 */
@Data
public class LatentDangerNormalParam {

    /**
     * 隐患名称
     */
    private String dangerName;

    /**
     * 隐患等级（1：一般隐患；2：重大隐患；3：安全问题）
     */
    private Integer dangerLevel;

    /**
     * 隐患地点
     */
    private String dangerPosition;

    /**
     * 备注
     */
    private String remark;

    /**
     * 拍照路径集合（多个逗号分开）
     */
    private String photoUrls;

    /**
     * 建筑id
     */
    private Long structureId;

    /**
     * 建筑名称
     */
    private String structureName;

    /**
     * 隐患地址经度
     */
    private String longitude;

    /**
     * 隐患地址纬度
     */
    private String latitude;

    /**
     * 业务类型（不同业务创建的隐患以此区分）
     */
    private String bizType;
}
