package com.yeejoin.amos.patrol.business.vo;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import com.fasterxml.jackson.databind.ser.std.ToStringSerializer;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import java.util.Date;

/**
 * @author keyong
 * @title: DefectVo
 * <pre>
 * @description: TODO
 * </pre>
 * @date 2023/4/22 22:30
 */
@Data
public class DefectVo {

    private String id;
    @ApiModelProperty(value = "缺陷等级1-一般 2-严重 3-危急")
    private Integer defectLevel;
    @ApiModelProperty(value = "缺陷设备ids")
    private String defectEquipmentIds;
    @ApiModelProperty(value = "缺陷设备名称")
    private String defectEquipmentName;
    @ApiModelProperty(value = "缺陷设备类型1-装备2-系统3-水源")
    private Integer defectEquipmentType;
    @ApiModelProperty(value = "缺陷描述")
    private String defectDescribe;
    @ApiModelProperty(value = "缺陷来源 1-巡查 2-维保 3-消防检测 4-其他")
    private Integer defectResource;
    @ApiModelProperty(value = "缺陷类型")
    private String defectType;
    @ApiModelProperty(value = "缺陷图片")
    private String defectImg;
    @ApiModelProperty(value = "发现日期")
    private Date defectDiscoverDate;
    @ApiModelProperty(value = "发现人")
    private String defectDiscover;
    @ApiModelProperty(value = "计划消缺日期")
    private Date planClearDate;
    @ApiModelProperty(value = "责任人")
    private String defectResponsible;
    @ApiModelProperty(value = "处理状态(0：未处理，1：已处理，2：处理中)")
    private Integer defectStatus;
    @ApiModelProperty(value = "是否需要停电处理(0：不需要，1：需要)")
    private Integer isPowerCut;
    @ApiModelProperty(value = "换流站名称")
    private String bizOrgName;
    @ApiModelProperty(value = "机构编码")
    private String bizOrgCode;
    @ApiModelProperty(value = "公司编码")
    private String orgCode;
    @ApiModelProperty(value = "添加时间")
    private Date addTime;
    @ApiModelProperty(value = "处理措施/处理情况")
    private String handleSituation;
    @ApiModelProperty(value = "处理-图片")
    private String handleImg;
    @ApiModelProperty(value = "工作票号")
    private String handleWorkTicketNum;
    @ApiModelProperty(value = "工作负责人")
    private String handleWorkLeader;
    @ApiModelProperty(value = "工作票是否已消号 1-已消号 0 -未消号")
    private Integer handleWorkIdTicket;
    @ApiModelProperty(value = "负责人检查日期")
    private String handleLeaderDate;
    @ApiModelProperty(value = "负责人")
    private String handleLeader;
    @ApiModelProperty(value = "消缺日期")
    private Date handleClearDate;
    @ApiModelProperty(value = "消缺人")
    private String handleClearPerson;
    @ApiModelProperty(value = "缺陷编号")
    private String defectNum;
    @ApiModelProperty(value = "超期提醒")
    private String expiredWarning;
    @ApiModelProperty(value = "缺陷状态【装备用】")
    private String defectStatusName;
    @ApiModelProperty(value = "告警id")
    private String batchId;
    @ApiModelProperty(value = "设备code")
    private String defectEquipmentCode;
}
