package com.yeejoin.amos.boot.module.ymt.api.entity;

import java.util.Date;

import org.typroject.tyboot.core.rdbms.orm.entity.BaseEntity;

import com.baomidou.mybatisplus.annotation.TableName;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

/**
 * 特种设备基本信息-使用信息
 *
 * @author duanwei
 * @date 2022-07-26
 */
@Data
@EqualsAndHashCode(callSuper = true)
@Accessors(chain = true)
@TableName("tz_jg_use_info")
@ApiModel(value = "TzsJgUseInfo对象", description = "特种设备基本信息-使用信息")
public class TzsJgUseInfo extends BaseEntity {

	private static final long serialVersionUID = 1L;

	@ApiModelProperty(value = "设备唯一标识码")
	private String sequenceCode;

	@ApiModelProperty(value = "监管系统唯一编码")
	private String superviseCode;

	@ApiModelProperty(value = "使用单位统一信用代码")
	private String useUnitCreditCode;

	@ApiModelProperty(value = "使用单位名称")
	private String useUnitName;

	@ApiModelProperty(value = "产权单位统一信用代码")
	private String estateUnitCreditCode;

	@ApiModelProperty(value = "产权单位名称")
	private String estateUnitName;

	@ApiModelProperty(value = "使用状态变更日期")
	private Date useStateChangeDate;

	@ApiModelProperty(value = "变更事项(使用单位名称变更、变更使用单位、改造/移装变更、延期使用变更)")
	private String changes;

	@ApiModelProperty(value = "使用内部编号")
	private String useInnerCode;

	@ApiModelProperty(value = "投入使用日期")
	private Date useDate;

	@ApiModelProperty(value = "经办人")
	private String agent;

	@ApiModelProperty(value = "设备所在地区代码")
	private String areaCode;

	@ApiModelProperty(value = "设备使用地点_省")
	private String province;

	@ApiModelProperty(value = "设备使用地点_市")
	private String city;

	@ApiModelProperty(value = "设备使用地点_区（县）")
	private String county;

	@ApiModelProperty(value = "设备使用地点_街道（镇）")
	private String street;

	@ApiModelProperty(value = "设备详细使用地址")
	private String address;

	@ApiModelProperty(value = "设备地理坐标经度")
	private String longitude;

	@ApiModelProperty(value = "设备地理坐标纬度")
	private String latitude;

	@ApiModelProperty(value = "设备使用场所(住宅小区、商业单位、学校、医院、政府机关、重要公共场所)")
	private String usePlace;

	@ApiModelProperty(value = "设备主管部门(药监局、经信委、文化委、市政市容委、发改委、水务局、住房建设委、交通局、商务委、旅游局、体育局、住房建设委、园林绿化局、水利局、商务委、卫生局、教育局等)")
	private String equManageDt;

	@ApiModelProperty(value = "安全管理部门名称")
	private String safetyManageDt;

	@ApiModelProperty(value = "安全管理员")
	private String safetyManager;

	@ApiModelProperty(value = "安全管理员移动电话")
	private Long phone;

	@ApiModelProperty(value = "设备状态(1在用2停用3报废 4注销5迁出 6拆除 7目录外 8非法设备)")
	private String equState;

	@ApiModelProperty(value = "同步时间")
	private Date syncDate;

	@ApiModelProperty(value = "同步状态（0-新增   1-更新   2-删除）")
	private Integer syncState;

	@ApiModelProperty(value = "对接公司编码")
	private String appId;

}
