package com.yeejoin.amos.boot.module.ymt.flc.biz.controller;

import com.yeejoin.amos.boot.module.ymt.flc.biz.service.impl.CylinderIntegrityDataServiceImpl;
import org.springframework.web.bind.annotation.RequestMapping;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.Api;
import org.springframework.web.bind.annotation.RestController;
import com.yeejoin.amos.boot.biz.common.controller.BaseController;
import java.util.List;

import org.typroject.tyboot.core.restful.utils.ResponseHelper;
import org.typroject.tyboot.core.restful.utils.ResponseModel;
import org.springframework.beans.factory.annotation.Autowired;
import javax.servlet.http.HttpServletRequest;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.ymt.flc.api.dto.CylinderIntegrityDataDto;
import org.typroject.tyboot.core.restful.doc.TycloudOperation;
import org.typroject.tyboot.core.foundation.enumeration.UserType;

/**
 * 气瓶数据完整度表
 *
 * @author system_generator
 * @date 2022-03-08
 */
@RestController
@Api(tags = "气瓶数据完整度表Api")
@RequestMapping(value = "/cylinder-integrity-data")
public class CylinderIntegrityDataController extends BaseController {

    @Autowired
    CylinderIntegrityDataServiceImpl cylinderIntegrityDataServiceImpl;

    /**
     * 新增气瓶数据完整度表
     *
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
	@PostMapping(value = "/save")
	@ApiOperation(httpMethod = "POST", value = "新增气瓶数据完整度表", notes = "新增气瓶数据完整度表")
	public ResponseModel<CylinderIntegrityDataDto> save(@RequestBody CylinderIntegrityDataDto model) {
	    model = cylinderIntegrityDataServiceImpl.createWithModel(model);
	    return ResponseHelper.buildResponse(model);
	}

	/**
     * 根据sequenceNbr更新
     *
     * @param sequenceNbr 主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@PutMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "PUT", value = "根据sequenceNbr更新气瓶数据完整度表", notes = "根据sequenceNbr更新气瓶数据完整度表")
	public ResponseModel<CylinderIntegrityDataDto> updateBySequenceNbrCylinderIntegrityData(@RequestBody CylinderIntegrityDataDto model,@PathVariable(value = "sequenceNbr") Long sequenceNbr) {
	    model.setSequenceNbr(sequenceNbr);
	    return ResponseHelper.buildResponse(cylinderIntegrityDataServiceImpl.updateWithModel(model));
	}

	/**
     * 根据sequenceNbr删除
     *
     * @param sequenceNbr 主键
     * @return
     */
    @TycloudOperation(ApiLevel = UserType.AGENCY)
    @DeleteMapping(value = "/{sequenceNbr}")
    @ApiOperation(httpMethod = "DELETE", value = "根据sequenceNbr删除气瓶数据完整度表", notes = "根据sequenceNbr删除气瓶数据完整度表")
    public ResponseModel<Boolean> deleteBySequenceNbr(HttpServletRequest request, @PathVariable(value = "sequenceNbr") Long sequenceNbr){
        return ResponseHelper.buildResponse(cylinderIntegrityDataServiceImpl.removeById(sequenceNbr));
    }

    /**
     * 根据sequenceNbr查询
     *
	 * @param sequenceNbr  主键
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/{sequenceNbr}")
	@ApiOperation(httpMethod = "GET",value = "根据sequenceNbr查询单个气瓶数据完整度表",  notes = "根据sequenceNbr查询单个气瓶数据完整度表")
	public ResponseModel<CylinderIntegrityDataDto> selectOne(@PathVariable Long sequenceNbr) {
	    return ResponseHelper.buildResponse(cylinderIntegrityDataServiceImpl.queryBySeq(sequenceNbr));
	}

	/**
     * 列表分页查询
     *
     * @param current 当前页
     * @param current 每页大小
     * @return
     */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@GetMapping(value = "/page")
	@ApiOperation(httpMethod = "GET",value = "气瓶数据完整度表分页查询",  notes = "气瓶数据完整度表分页查询")
	public ResponseModel<Page<CylinderIntegrityDataDto>> queryForPage(@RequestParam(value = "current") int current,@RequestParam
                    (value = "size") int size) {
	    Page<CylinderIntegrityDataDto> page = new Page<CylinderIntegrityDataDto>();
	    page.setCurrent(current);
	    page.setSize(size);
	    return ResponseHelper.buildResponse(cylinderIntegrityDataServiceImpl.queryForCylinderIntegrityDataPage(page));
	}

	/**
	 * 列表全部数据查询
     *
	 * @return
	 */
	@TycloudOperation(ApiLevel = UserType.AGENCY)
	@ApiOperation(httpMethod = "GET",value = "气瓶数据完整度表列表全部数据查询",   notes = "气瓶数据完整度表列表全部数据查询")
	@GetMapping(value = "/list")
	public ResponseModel<List<CylinderIntegrityDataDto>> selectForList() {
	    return ResponseHelper.buildResponse(cylinderIntegrityDataServiceImpl.queryForCylinderIntegrityDataList());
	}
}
