package com.yeejoin.amos.boot.module.ys.api.service;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.yeejoin.amos.boot.module.ys.api.dto.YsEmergencyCaseDto;
import com.yeejoin.amos.feign.privilege.model.AgencyUserModel;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;
import org.typroject.tyboot.core.restful.utils.ResponseModel;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * 救援案例管理接口类
 *
 * @author system_generator
 * @date 2024-09-24
 */
public interface IYsEmergencyCaseService {

    @Transactional(rollbackFor = Exception.class)
    Boolean saveOrUpdate(YsEmergencyCaseDto dto, AgencyUserModel userModel);

    Page<YsEmergencyCaseDto> queryForYsEmergencyCasePage(Page<YsEmergencyCaseDto> page,String sort, YsEmergencyCaseDto dto);

    Boolean deleteById(String sequenceNbr);

    YsEmergencyCaseDto queryBySequenceNbr (String sequenceNbr);

    void export(HttpServletResponse response, List<String> ids);

    @Transactional(rollbackFor = Exception.class)
    ResponseModel<Object> expertDataImport(MultipartFile file, AgencyUserModel userModel);
}
